Index: lib/oauth2.c
===================================================================
--- lib/oauth2.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ lib/oauth2.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -4,5 +4,5 @@
 *  Simple OAuth client (consumer) implementation.                           *
 *                                                                           *
-*  Copyright 2010-2012 Wilmer van der Gaast <wilmer@gaast.net>              *
+*  Copyright 2010-2011 Wilmer van der Gaast <wilmer@gaast.net>              *
 *                                                                           *
 *  This program is free software; you can redistribute it and/or modify     *
@@ -26,5 +26,4 @@
 #include "oauth2.h"
 #include "oauth.h"
-#include "json.h"
 #include "url.h"
 
@@ -45,4 +44,5 @@
 };
 
+static char *oauth2_json_dumb_get( const char *json, const char *key );
 static void oauth2_access_token_done( struct http_request *req );
 
@@ -115,20 +115,6 @@
 	else if( content_type && strstr( content_type, "application/json" ) )
 	{
-		json_value *js = json_parse( req->reply_body );
-		if( js && js->type == json_object )
-		{
-			int i;
-			
-			for( i = 0; i < js->u.object.length; i ++ )
-			{
-				if( js->u.object.values[i].value->type != json_string )
-					continue;
-				if( strcmp( js->u.object.values[i].name, "access_token" ) == 0 )
-					atoken = g_strdup( js->u.object.values[i].value->u.string.ptr );
-				if( strcmp( js->u.object.values[i].name, "refresh_token" ) == 0 )
-					rtoken = g_strdup( js->u.object.values[i].value->u.string.ptr );
-			}
-		}
-		json_value_free( js );
+		atoken = oauth2_json_dumb_get( req->reply_body, "access_token" );
+		rtoken = oauth2_json_dumb_get( req->reply_body, "refresh_token" );
 	}
 	else
@@ -151,2 +137,61 @@
 	g_free( cb_data );
 }
+
+/* Super dumb. I absolutely refuse to use/add a complete json parser library
+   (adding a new dependency to BitlBee for the first time in.. 6 years?) just
+   to parse 100 bytes of data. So I have to do my own parsing because OAuth2
+   dropped support for XML. (GRRR!) This is very dumb and for example won't
+   work for integer values, nor will it strip/handle backslashes. */
+static char *oauth2_json_dumb_get( const char *json, const char *key )
+{
+	int is_key = 0; /* 1 == reading key, 0 == reading value */
+	int found_key = 0;
+		
+	while( json && *json )
+	{
+		/* Grab strings and see if they're what we're looking for. */
+		if( *json == '"' || *json == '\'' )
+		{
+			char q = *json;
+			const char *str_start;
+			json ++;
+			str_start = json;
+			
+			while( *json )
+			{
+				/* \' and \" are not string terminators. */
+				if( *json == '\\' && json[1] == q )
+					json ++;
+				/* But without a \ it is. */
+				else if( *json == q )
+					break;
+				json ++;
+			}
+			if( *json == '\0' )
+				return NULL;
+			
+			if( is_key && strncmp( str_start, key, strlen( key ) ) == 0 )
+			{
+				found_key = 1;
+			}
+			else if( !is_key && found_key )
+			{
+				char *ret = g_memdup( str_start, json - str_start + 1 );
+				ret[json-str_start] = '\0';
+				return ret;
+			}
+			
+		}
+		else if( *json == '{' || *json == ',' )
+		{
+			found_key = 0;
+			is_key = 1;
+		}
+		else if( *json == ':' )
+			is_key = 0;
+		
+		json ++;
+	}
+	
+	return NULL;
+}
Index: lib/ssl_gnutls.c
===================================================================
--- lib/ssl_gnutls.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ lib/ssl_gnutls.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -38,5 +38,5 @@
 
 static gboolean initialized = FALSE;
-gnutls_certificate_credentials_t xcred;
+gnutls_certificate_credentials xcred;
 
 #include <limits.h>
@@ -60,5 +60,5 @@
 	gboolean verify;
 	
-	gnutls_session_t session;
+	gnutls_session session;
 };
 
@@ -134,5 +134,5 @@
 	conn->data = data;
 	conn->inpa = -1;
-	conn->hostname = g_strdup( hostname );
+	conn->hostname = hostname;
 	
 	/* For now, SSL verification is globally enabled by setting the cafile
@@ -171,7 +171,7 @@
 	int verifyret = 0;
 	gnutls_x509_crt_t cert;
-	struct scd *conn;
-	
-	conn = gnutls_session_get_ptr( session );
+	const char *hostname;
+	
+	hostname = gnutls_session_get_ptr( session );
 
 	gnutlsret = gnutls_certificate_verify_peers2( session, &status );
@@ -211,5 +211,5 @@
 		return VERIFY_CERT_ERROR;
 
-	if( !gnutls_x509_crt_check_hostname( cert, conn->hostname ) )
+	if( !gnutls_x509_crt_check_hostname( cert, hostname ) )
 	{
 		verifyret |= VERIFY_CERT_INVALID;
@@ -267,5 +267,6 @@
 	
 	gnutls_init( &conn->session, GNUTLS_CLIENT );
-	gnutls_session_set_ptr( conn->session, (void *) conn );
+	if( conn->verify )
+		gnutls_session_set_ptr( conn->session, (void *) conn->hostname );
 #if GNUTLS_VERSION_NUMBER < 0x020c00
 	gnutls_transport_set_lowat( conn->session, 0 );
@@ -275,5 +276,5 @@
 	
 	sock_make_nonblocking( conn->fd );
-	gnutls_transport_set_ptr( conn->session, (gnutls_transport_ptr_t) GNUTLS_STUPID_CAST conn->fd );
+	gnutls_transport_set_ptr( conn->session, (gnutls_transport_ptr) GNUTLS_STUPID_CAST conn->fd );
 	
 	return ssl_handshake( data, source, cond );
@@ -401,5 +402,4 @@
 	if( conn->session )
 		gnutls_deinit( conn->session );
-	g_free( conn->hostname );
 	g_free( conn );
 }
Index: nick.c
===================================================================
--- nick.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ nick.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -134,8 +134,5 @@
 				chop = fmt[1];
 				if( chop == '\0' )
-				{
-					g_string_free( ret, TRUE );
 					return NULL;
-				}
 				fmt += 2;
 			}
@@ -190,5 +187,4 @@
 			else
 			{
-				g_string_free( ret, TRUE );
 				return NULL;
 			}
Index: protocols/msn/msn.c
===================================================================
--- protocols/msn/msn.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/msn/msn.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -53,5 +53,4 @@
 	
 	ic->proto_data = md;
-	ic->flags |= OPT_PONGS | OPT_PONGED;
 	
 	if( strchr( acc->user, '@' ) == NULL )
Index: protocols/msn/ns.c
===================================================================
--- protocols/msn/ns.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/msn/ns.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -576,8 +576,4 @@
 		if( num_parts >= 7 )
 			handler->msglen = atoi( cmd[6] );
-	}
-	else if( strcmp( cmd[0], "QNG" ) == 0 )
-	{
-		ic->flags |= OPT_PONGED;
 	}
 	else if( isdigit( cmd[0][0] ) )
Index: protocols/nogaim.c
===================================================================
--- protocols/nogaim.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/nogaim.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -261,28 +261,8 @@
 	struct im_connection *ic = d;
 	
-	if( ( ic->flags & OPT_PONGS ) && !( ic->flags & OPT_PONGED ) )
-	{
-		/* This protocol is expected to ack keepalives and hasn't
-		   since the last time we were here. */
-		imcb_error( ic, "Connection timeout" );
-		imc_logout( ic, TRUE );
-		return FALSE;
-	}
-	ic->flags &= ~OPT_PONGED;
-	
 	if( ic->acc->prpl->keepalive )
 		ic->acc->prpl->keepalive( ic );
 	
 	return TRUE;
-}
-
-void start_keepalives( struct im_connection *ic, int interval )
-{
-	b_event_remove( ic->keepalive );
-	ic->keepalive = b_timeout_add( interval, send_keepalive, ic );
-	
-	/* Connecting successfully counts as a first successful pong. */
-	if( ic->flags & OPT_PONGS )
-		ic->flags |= OPT_PONGED;
 }
 
@@ -297,6 +277,7 @@
 	imcb_log( ic, "Logged in" );
 	
+	b_event_remove( ic->keepalive );
+	ic->keepalive = b_timeout_add( 60000, send_keepalive, ic );
 	ic->flags |= OPT_LOGGED_IN;
-	start_keepalives( ic, 60000 );
 	
 	/* Necessary to send initial presence status, even if we're not away. */
Index: protocols/nogaim.h
===================================================================
--- protocols/nogaim.h	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/nogaim.h	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -68,6 +68,4 @@
 #define OPT_THINKING    0x00000200 /* about these values... Stupid me! */
 #define OPT_NOOTR       0x00001000 /* protocol not suitable for OTR */
-#define OPT_PONGS       0x00010000 /* Service sends us keep-alives */
-#define OPT_PONGED      0x00020000 /* Received a keep-alive during last interval */
 
 /* ok. now the fun begins. first we create a connection structure */
Index: protocols/twitter/twitter.c
===================================================================
--- protocols/twitter/twitter.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/twitter/twitter.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -4,6 +4,5 @@
 *  Simple module to facilitate twitter functionality.                       *
 *                                                                           *
-*  Copyright 2009-2010 Geert Mulders <g.c.w.m.mulders@gmail.com>            *
-*  Copyright 2010-2012 Wilmer van der Gaast <wilmer@gaast.net>              *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
 *                                                                           *
 *  This library is free software; you can redistribute it and/or            *
@@ -30,5 +29,15 @@
 #include "url.h"
 
+#define twitter_msg( ic, fmt... ) \
+	do {                                            \
+		struct twitter_data *td = ic->proto_data;   \
+		if( td->timeline_gc )                       \
+			imcb_chat_log( td->timeline_gc, fmt );  \
+		else                                        \
+			imcb_log( ic, fmt );                    \
+	} while( 0 );
+
 GSList *twitter_connections = NULL;
+
 /**
  * Main loop function
@@ -53,55 +62,13 @@
 	struct twitter_data *td = ic->proto_data;
 
-	/* Create the room now that we "logged in". */
-	if (td->flags & TWITTER_MODE_CHAT)
-		twitter_groupchat_init(ic);
-
 	imcb_log(ic, "Getting initial statuses");
 
-	// Run this once. After this queue the main loop function (or open the
-	// stream if available).
+	// Run this once. After this queue the main loop function.
 	twitter_main_loop(ic, -1, 0);
-	
-	if (set_getbool(&ic->acc->set, "stream")) {
-		/* That fetch was just to get backlog, the stream will give
-		   us the rest. \o/ */
-		twitter_open_stream(ic);
-		
-		/* Stream sends keepalives (empty lines) or actual data at
-		   least twice a minute. Disconnect if this stops. */
-		ic->flags |= OPT_PONGS;
-	} else {
-		/* Not using the streaming API, so keep polling the old-
-		   fashioned way. :-( */
-		td->main_loop_id =
-		    b_timeout_add(set_getint(&ic->acc->set, "fetch_interval") * 1000,
-		                  twitter_main_loop, ic);
-	}
-}
-
-struct groupchat *twitter_groupchat_init(struct im_connection *ic)
-{
-	char *name_hint;
-	struct groupchat *gc;
-	struct twitter_data *td = ic->proto_data;
-	GSList *l;
-
-	if (td->timeline_gc)
-		return td->timeline_gc;
-
-	td->timeline_gc = gc = imcb_chat_new(ic, "twitter/timeline");
-
-	name_hint = g_strdup_printf("%s_%s", td->prefix, ic->acc->user);
-	imcb_chat_name_hint(gc, name_hint);
-	g_free(name_hint);
-
-	for (l = ic->bee->users; l; l = l->next) {
-		bee_user_t *bu = l->data;
-		if (bu->ic == ic)
-			imcb_chat_add_buddy(gc, bu->handle);
-	}
-	imcb_chat_add_buddy(gc, ic->acc->user);
-	
-	return gc;
+
+	// Queue the main_loop
+	// Save the return value, so we can remove the timeout on logout.
+	td->main_loop_id =
+	    b_timeout_add(set_getint(&ic->acc->set, "fetch_interval") * 1000, twitter_main_loop, ic);
 }
 
@@ -116,8 +83,9 @@
 	if (set_getbool(&ic->acc->set, "oauth") && !td->oauth_info)
 		twitter_oauth_start(ic);
-	else if (!(td->flags & TWITTER_MODE_ONE) &&
-	         !(td->flags & TWITTER_HAVE_FRIENDS)) {
+	else if (g_strcasecmp(set_getstr(&ic->acc->set, "mode"), "one") != 0 &&
+		 !(td->flags & TWITTER_HAVE_FRIENDS)) {
 		imcb_log(ic, "Getting contact list");
 		twitter_get_friends_ids(ic, -1);
+		//twitter_get_statuses_friends(ic, -1);
 	} else
 		twitter_main_loop_start(ic);
@@ -219,4 +187,14 @@
 }
 
+
+static char *set_eval_mode(set_t * set, char *value)
+{
+	if (g_strcasecmp(value, "one") == 0 ||
+	    g_strcasecmp(value, "many") == 0 || g_strcasecmp(value, "chat") == 0)
+		return value;
+	else
+		return NULL;
+}
+
 int twitter_url_len_diff(gchar *msg, unsigned int target_len)
 {
@@ -255,24 +233,7 @@
 		return TRUE;
 
-	twitter_log(ic, "Maximum message length exceeded: %d > %d", len, max);
+	imcb_error(ic, "Maximum message length exceeded: %d > %d", len, max);
 
 	return FALSE;
-}
-
-static char *set_eval_commands(set_t * set, char *value)
-{
-	if (g_strcasecmp(value, "strict") == 0 )
-		return value;
-	else
-		return set_eval_bool(set, value);
-}
-
-static char *set_eval_mode(set_t * set, char *value)
-{
-	if (g_strcasecmp(value, "one") == 0 ||
-	    g_strcasecmp(value, "many") == 0 || g_strcasecmp(value, "chat") == 0)
-		return value;
-	else
-		return NULL;
 }
 
@@ -296,5 +257,5 @@
 	s->flags |= ACC_SET_OFFLINE_ONLY;
 
-	s = set_add(&acc->set, "commands", "true", set_eval_commands, acc);
+	s = set_add(&acc->set, "commands", "true", set_eval_bool, acc);
 
 	s = set_add(&acc->set, "fetch_interval", "60", set_eval_int, acc);
@@ -313,17 +274,13 @@
 
 	s = set_add(&acc->set, "show_ids", "true", set_eval_bool, acc);
+	s->flags |= ACC_SET_OFFLINE_ONLY;
 
 	s = set_add(&acc->set, "show_old_mentions", "20", set_eval_int, acc);
 
 	s = set_add(&acc->set, "strip_newlines", "false", set_eval_bool, acc);
-	
-	if (strcmp(acc->prpl->name, "twitter") == 0) {
-		s = set_add(&acc->set, "stream", "true", set_eval_bool, acc);
-		s->flags |= ACC_SET_OFFLINE_ONLY;
-	}
 }
 
 /**
- * Login method. Since the twitter API works with separate HTTP request we
+ * Login method. Since the twitter API works with seperate HTTP request we 
  * only save the user and pass to the twitter_data object.
  */
@@ -341,10 +298,4 @@
 		imc_logout(ic, FALSE);
 		return;
-	}
-
-	if (!strstr(url.host, "twitter.com") &&
-	    set_getbool(&ic->acc->set, "stream")) {
-		imcb_error(ic, "Warning: The streaming API is only supported by Twitter, "
-		               "and you seem to be connecting to a different service.");
 	}
 
@@ -389,14 +340,6 @@
 	imcb_buddy_status(ic, name, OPT_LOGGED_IN, NULL, NULL);
 
-	td->log = g_new0(struct twitter_log_data, TWITTER_LOG_LENGTH);
-	td->log_id = -1;
-	
-	s = set_getstr(&ic->acc->set, "mode");
-	if (g_strcasecmp(s, "one") == 0)
-		td->flags |= TWITTER_MODE_ONE;
-	else if (g_strcasecmp(s, "many") == 0)
-		td->flags |= TWITTER_MODE_MANY;
-	else
-		td->flags |= TWITTER_MODE_CHAT;
+	if (set_getbool(&acc->set, "show_ids"))
+		td->log = g_new0(struct twitter_log_data, TWITTER_LOG_LENGTH);
 
 	twitter_login_finish(ic);
@@ -420,5 +363,4 @@
 
 	if (td) {
-		http_close(td->stream);
 		oauth_info_free(td->oauth_info);
 		g_free(td->user);
@@ -553,38 +495,19 @@
  *  Returns 0 if the user provides garbage.
  */
-static guint64 twitter_message_id_from_command_arg(struct im_connection *ic, char *arg, bee_user_t **bu_) {
-	struct twitter_data *td = ic->proto_data;
+static guint64 twitter_message_id_from_command_arg(struct im_connection *ic, struct twitter_data *td, char *arg) {
 	struct twitter_user_data *tud;
-	bee_user_t *bu = NULL;
+	bee_user_t *bu;
 	guint64 id = 0;
-	
-	if (bu_)
-		*bu_ = NULL;
-	if (!arg || !arg[0])
-		return 0;
-	
-	if (arg[0] != '#' && (bu = bee_user_by_handle(ic->bee, ic, arg))) {
-		if ((tud = bu->data))
-			id = tud->last_id;
-	} else {
-		if (arg[0] == '#')
-			arg++;
-		if (sscanf(arg, "%" G_GINT64_MODIFIER "x", &id) == 1 &&
-		    id < TWITTER_LOG_LENGTH) {
-			bu = td->log[id].bu;
+	if (g_str_has_prefix(arg, "#") &&
+		sscanf(arg + 1, "%" G_GUINT64_FORMAT, &id) == 1) {
+		if (id < TWITTER_LOG_LENGTH && td->log)
 			id = td->log[id].id;
-			/* Beware of dangling pointers! */
-			if (!g_slist_find(ic->bee->users, bu))
-				bu = NULL;
-		} else if (sscanf(arg, "%" G_GINT64_MODIFIER "d", &id) == 1) {
-			/* Allow normal tweet IDs as well; not a very useful
-			   feature but it's always been there. Just ignore
-			   very low IDs to avoid accidents. */
-			if (id < 1000000)
-				id = 0;
-		}
-	}
-	if (bu_)
-		*bu_ = bu;
+	} else if ((bu = bee_user_by_handle(ic->bee, ic, arg)) &&
+		(tud = bu->data) && tud->last_id)
+		id = tud->last_id;
+	else if (sscanf(arg, "%" G_GUINT64_FORMAT, &id) == 1){
+		if (id < TWITTER_LOG_LENGTH && td->log)
+			id = td->log[id].id;
+	}
 	return id;
 }
@@ -594,8 +517,5 @@
 	struct twitter_data *td = ic->proto_data;
 	char *cmds, **cmd, *new = NULL;
-	guint64 in_reply_to = 0, id;
-	gboolean allow_post =
-		g_strcasecmp(set_getstr(&ic->acc->set, "commands"), "strict") != 0;
-	bee_user_t *bu = NULL;
+	guint64 in_reply_to = 0;
 
 	cmds = g_strdup(message);
@@ -603,45 +523,60 @@
 
 	if (cmd[0] == NULL) {
-		goto eof;
-	} else if (!set_getbool(&ic->acc->set, "commands") && allow_post) {
-		/* Not supporting commands if "commands" is set to true/strict. */
+		g_free(cmds);
+		return;
+	} else if (!set_getbool(&ic->acc->set, "commands")) {
+		/* Not supporting commands. */
 	} else if (g_strcasecmp(cmd[0], "undo") == 0) {
+		guint64 id;
+
 		if (cmd[1] == NULL)
 			twitter_status_destroy(ic, td->last_status_id);
-		else if ((id = twitter_message_id_from_command_arg(ic, cmd[1], NULL)))
+		else if (sscanf(cmd[1], "%" G_GUINT64_FORMAT, &id) == 1) {
+			if (id < TWITTER_LOG_LENGTH && td->log)
+				id = td->log[id].id;
+			
 			twitter_status_destroy(ic, id);
-		else
-			twitter_log(ic, "Could not undo last action");
-
-		goto eof;
+		} else
+			twitter_msg(ic, "Could not undo last action");
+
+		g_free(cmds);
+		return;
 	} else if (g_strcasecmp(cmd[0], "favourite") == 0 && cmd[1]) {
-		if ((id = twitter_message_id_from_command_arg(ic, cmd[1], NULL))) {
+		guint64 id;
+		if ((id = twitter_message_id_from_command_arg(ic, td, cmd[1]))) {
 			twitter_favourite_tweet(ic, id);
 		} else {
-			twitter_log(ic, "Please provide a message ID or username.");
-		}
-		goto eof;
+			twitter_msg(ic, "Please provide a message ID or username.");
+		}
+		g_free(cmds);
+		return;
 	} else if (g_strcasecmp(cmd[0], "follow") == 0 && cmd[1]) {
 		twitter_add_buddy(ic, cmd[1], NULL);
-		goto eof;
+		g_free(cmds);
+		return;
 	} else if (g_strcasecmp(cmd[0], "unfollow") == 0 && cmd[1]) {
 		twitter_remove_buddy(ic, cmd[1], NULL);
-		goto eof;
+		g_free(cmds);
+		return;
 	} else if ((g_strcasecmp(cmd[0], "report") == 0 ||
 	            g_strcasecmp(cmd[0], "spam") == 0) && cmd[1]) {
-		char *screen_name;
-		
+		char * screen_name;
+		guint64 id;
+		screen_name = cmd[1];
 		/* Report nominally works on users but look up the user who
 		   posted the given ID if the user wants to do it that way */
-		twitter_message_id_from_command_arg(ic, cmd[1], &bu);
-		if (bu)
-			screen_name = bu->handle;
-		else
-			screen_name = cmd[1];
-		
+		if (g_str_has_prefix(cmd[1], "#") &&
+		    sscanf(cmd[1] + 1, "%" G_GUINT64_FORMAT, &id) == 1) {
+			if (id < TWITTER_LOG_LENGTH && td->log) {
+				if (g_slist_find(ic->bee->users, td->log[id].bu)) {
+					screen_name = td->log[id].bu->handle;
+				}
+			}
+		}
 		twitter_report_spam(ic, screen_name);
-		goto eof;
+		g_free(cmds);
+		return;
 	} else if (g_strcasecmp(cmd[0], "rt") == 0 && cmd[1]) {
-		id = twitter_message_id_from_command_arg(ic, cmd[1], NULL);
+		guint64 id = twitter_message_id_from_command_arg(ic, td, cmd[1]);
 
 		td->last_status_id = 0;
@@ -649,28 +584,55 @@
 			twitter_status_retweet(ic, id);
 		else
-			twitter_log(ic, "User `%s' does not exist or didn't "
+			twitter_msg(ic, "User `%s' does not exist or didn't "
 				    "post any statuses recently", cmd[1]);
 
-		goto eof;
+		g_free(cmds);
+		return;
 	} else if (g_strcasecmp(cmd[0], "reply") == 0 && cmd[1] && cmd[2]) {
-		id = twitter_message_id_from_command_arg(ic, cmd[1], &bu);
+		struct twitter_user_data *tud;
+		bee_user_t *bu = NULL;
+		guint64 id = 0;
+
+		if (g_str_has_prefix(cmd[1], "#") &&
+		    sscanf(cmd[1] + 1, "%" G_GUINT64_FORMAT, &id) == 1 &&
+		    (id < TWITTER_LOG_LENGTH) && td->log) {
+			bu = td->log[id].bu;
+			if (g_slist_find(ic->bee->users, bu))
+				id = td->log[id].id;
+			else
+				bu = NULL;
+		} else if ((bu = bee_user_by_handle(ic->bee, ic, cmd[1])) &&
+		    (tud = bu->data) && tud->last_id) {
+			id = tud->last_id;
+		} else if (sscanf(cmd[1], "%" G_GUINT64_FORMAT, &id) == 1 &&
+		           (id < TWITTER_LOG_LENGTH) && td->log) {
+			bu = td->log[id].bu;
+			if (g_slist_find(ic->bee->users, bu))
+				id = td->log[id].id;
+			else
+				bu = NULL;
+		}
+
 		if (!id || !bu) {
-			twitter_log(ic, "User `%s' does not exist or didn't "
+			twitter_msg(ic, "User `%s' does not exist or didn't "
 				    "post any statuses recently", cmd[1]);
-			goto eof;
+			g_free(cmds);
+			return;
 		}
 		message = new = g_strdup_printf("@%s %s", bu->handle, message + (cmd[2] - cmd[0]));
 		in_reply_to = id;
-		allow_post = TRUE;
 	} else if (g_strcasecmp(cmd[0], "post") == 0) {
 		message += 5;
-		allow_post = TRUE;
-	}
-
-	if (allow_post) {
+	}
+
+	{
 		char *s;
-
-		if (!twitter_length_check(ic, message))
-			goto eof;
+		bee_user_t *bu;
+
+		if (!twitter_length_check(ic, message)) {
+			g_free(new);
+			g_free(cmds);
+			return;
+		}
 
 		s = cmd[0] + strlen(cmd[0]) - 1;
@@ -695,30 +657,8 @@
 		td->last_status_id = 0;
 		twitter_post_status(ic, message, in_reply_to);
-	} else {
-		twitter_log(ic, "Unknown command: %s", cmd[0]);
-	}
-eof:
-	g_free(new);
+		g_free(new);
+	}
 	g_free(cmds);
 }
-
-void twitter_log(struct im_connection *ic, char *format, ... )
-{
-	struct twitter_data *td = ic->proto_data;
-	va_list params;
-	char *text;
-	
-	va_start(params, format);
-	text = g_strdup_vprintf(format, params);
-	va_end(params);
-	
-	if (td->timeline_gc)
-		imcb_chat_log(td->timeline_gc, "%s", text);
-	else
-		imcb_log(ic, "%s", text);
-	
-	g_free(text);
-}
-
 
 void twitter_initmodule()
Index: protocols/twitter/twitter.h
===================================================================
--- protocols/twitter/twitter.h	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/twitter/twitter.h	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -4,6 +4,5 @@
 *  Simple module to facilitate twitter functionality.                       *
 *                                                                           *
-*  Copyright 2009-2010 Geert Mulders <g.c.w.m.mulders@gmail.com>            *
-*  Copyright 2010-2012 Wilmer van der Gaast <wilmer@gaast.net>              *
+*  Copyright 2009 Geert Mulders <g.c.w.m.mulders@gmail.com>                 *
 *                                                                           *
 *  This library is free software; you can redistribute it and/or            *
@@ -36,11 +35,8 @@
 typedef enum
 {
-	TWITTER_HAVE_FRIENDS   = 0x00001,
-	TWITTER_MODE_ONE       = 0x00002,
-	TWITTER_MODE_MANY      = 0x00004,
-	TWITTER_MODE_CHAT      = 0x00008,
+	TWITTER_HAVE_FRIENDS = 1,
 	TWITTER_DOING_TIMELINE = 0x10000,
-	TWITTER_GOT_TIMELINE   = 0x20000,
-	TWITTER_GOT_MENTIONS   = 0x40000,
+	TWITTER_GOT_TIMELINE = 0x20000,
+	TWITTER_GOT_MENTIONS = 0x40000,
 } twitter_flags_t;
 
@@ -61,5 +57,4 @@
 	guint64 last_status_id; /* For undo */
 	gint main_loop_id;
-	struct http_request *stream;
 	struct groupchat *timeline_gc;
 	gint http_fails;
@@ -85,5 +80,5 @@
 };
 
-#define TWITTER_LOG_LENGTH 256
+#define TWITTER_LOG_LENGTH 100
 struct twitter_log_data
 {
@@ -104,6 +99,3 @@
 char *twitter_parse_error( struct http_request *req );
 
-void twitter_log(struct im_connection *ic, char *format, ... );
-struct groupchat *twitter_groupchat_init(struct im_connection *ic);
-
 #endif //_TWITTER_H
Index: protocols/twitter/twitter_http.c
===================================================================
--- protocols/twitter/twitter_http.c	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/twitter/twitter_http.c	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -47,6 +47,6 @@
  * This is actually pretty generic function... Perhaps it should move to the lib/http_client.c
  */
-struct http_request *twitter_http(struct im_connection *ic, char *url_string, http_input_function func,
-		                  gpointer data, int is_post, char **arguments, int arguments_len)
+void *twitter_http(struct im_connection *ic, char *url_string, http_input_function func,
+		   gpointer data, int is_post, char **arguments, int arguments_len)
 {
 	struct twitter_data *td = ic->proto_data;
@@ -55,5 +55,4 @@
 	void *ret;
 	char *url_arguments;
-	url_t *base_url = NULL;
 
 	url_arguments = g_strdup("");
@@ -68,13 +67,4 @@
 		}
 	}
-	
-	if (strstr(url_string, "://")) {
-		base_url = g_new0(url_t, 1);
-		if (!url_set(base_url, url_string)) {
-			g_free(base_url);
-			return NULL;
-		}
-	}
-	
 	// Make the request.
 	g_string_printf(request, "%s %s%s%s%s HTTP/1.0\r\n"
@@ -82,8 +72,6 @@
 			"User-Agent: BitlBee " BITLBEE_VERSION " " ARCH "/" CPU "\r\n",
 			is_post ? "POST" : "GET",
-			base_url ? base_url->file : td->url_path,
-			base_url ? "" : url_string,
-			is_post ? "" : "?", is_post ? "" : url_arguments,
-			base_url ? base_url->host : td->url_host);
+			td->url_path, url_string,
+			is_post ? "" : "?", is_post ? "" : url_arguments, td->url_host);
 
 	// If a pass and user are given we append them to the request.
@@ -92,8 +80,5 @@
 		char *full_url;
 
-		if (base_url)
-			full_url = g_strdup(url_string);
-		else
-			full_url = g_strconcat(set_getstr(&ic->acc->set, "base_url"), url_string, NULL);
+		full_url = g_strconcat(set_getstr(&ic->acc->set, "base_url"), url_string, NULL);
 		full_header = oauth_http_header(td->oauth_info, is_post ? "POST" : "GET",
 						full_url, url_arguments);
@@ -124,21 +109,8 @@
 	}
 
-	if (base_url)
-		ret = http_dorequest(base_url->host, base_url->port, base_url->proto == PROTO_HTTPS, request->str, func, data);
-	else
-		ret = http_dorequest(td->url_host, td->url_port, td->url_ssl, request->str, func, data);
+	ret = http_dorequest(td->url_host, td->url_port, td->url_ssl, request->str, func, data);
 
 	g_free(url_arguments);
 	g_string_free(request, TRUE);
-	g_free(base_url);
-	return ret;
-}
-
-struct http_request *twitter_http_f(struct im_connection *ic, char *url_string, http_input_function func,
-		                    gpointer data, int is_post, char **arguments, int arguments_len, twitter_http_flags_t flags)
-{
-	struct http_request *ret = twitter_http(ic, url_string, func, data, is_post, arguments, arguments_len);
-	if (ret)
-		ret->flags |= flags;
 	return ret;
 }
Index: protocols/twitter/twitter_http.h
===================================================================
--- protocols/twitter/twitter_http.h	(revision cc6fdf8fe5a044db58ed74e69673cf4270080d45)
+++ protocols/twitter/twitter_http.h	(revision 92d30446251591a6805168f51a4b07ff65b3cc24)
@@ -28,16 +28,8 @@
 #include "http_client.h"
 
-typedef enum {
-	/* With this set, twitter_http_post() will post a generic confirmation
-	   message to the user. */
-	TWITTER_HTTP_USER_ACK = 0x1000000,
-} twitter_http_flags_t;
-
 struct oauth_info;
 
-struct http_request *twitter_http(struct im_connection *ic, char *url_string, http_input_function func,
-                                  gpointer data, int is_post, char** arguments, int arguments_len);
-struct http_request *twitter_http_f(struct im_connection *ic, char *url_string, http_input_function func,
-                                    gpointer data, int is_post, char** arguments, int arguments_len, twitter_http_flags_t flags);
+void *twitter_http(struct im_connection *ic, char *url_string, http_input_function func,
+                   gpointer data, int is_post, char** arguments, int arguments_len);
 
 #endif //_TWITTER_HTTP_H
